MRE3 C# SDK

Loading...
Searching...
No Matches
Public Member Functions | Properties | List of all members
MrEModuleSdk.Devices.Mre3.MrE3SdkComDeviceController Class Reference
Inheritance diagram for MrEModuleSdk.Devices.Mre3.MrE3SdkComDeviceController:

## Public Member Functions
bool | Connect (int port)
| Connects to the device on given port.
void | Disconnect (bool cleanUp)
| Disconnects from the device.
bool | GoToDfuMode ()
| Switches device to DFU mode.
bool | ChangeModeToPro ()
| Switches device to PRO mode.
bool | ChangeModeToSimple ()
| Switches device to SIMPLE mode.
bool | IsConnected ()
| Returns true, if connection to device is established.
bool | Reconnect ()
| Reconnects to already connected device.
string | GetElectronicSerialNumber ()
| Returns serial number of the electronic.
string | GetProductSerialNumber ()
| Returns serial number of the product.
byte[] | GetBytes (int index, int length)
| Returns board EEPROM bytes starting at index provided as parameter.
void | SetBytes (int index, byte[] bytes)
| Sets board EEPROM bytes starting at index provided as parameter.
void | ResetErrorFlags ()
| Resets error flag to 0.
int | GetBoardFirmwareId ()
| Returns firmware ID of the electronic.
int | GetBoardFirmwareBranch ()
| Returns branch ID of the electronic.
char | GetBoardFirmwareType ()
| Returns type of the electronic.
int | GetBoardFirmwareMajorVersion ()
| Returns firmware major version of the electronic.
int | GetBoardFirmwareMinorVersion ()
| Returns firmware minor version of the electronic.
int | GetBoardFirmwareRevisionVersion ()
| Returns firmware revision version of the electronic.
int | GetBoardFirmwareBuildVersion ()
| Returns firmware build version of the electronic.
string | GetFirmwareSerialNumber ()
| Returns firmware serial number.
IDeviceErrorState[] | GetDeviceStatus ()
| Returns states of the device.
int | GetEepromVersion ()
| Returns EEPROM version.
int | GetEepromSubVersion ()
| Returns EEPROM subversion.
int | GetPartConfiguration ()
| Returns part configuration value.
int | GetPartConfigurationVersion ()
| Returns part configuration version value.
int | GetMaxPositiveCurrent ()
| Returns max positive current.
int | GetMaxNegativeCurrent ()
| Returns max negative current.
void | WriteCurrent (EAxis axis, float value)
| Sets static input in amperes. Range is from -0.7 to 0.7.
void | WriteOpticalFeedback (EAxis axis, float value)
| Sets static input in OF. Range differs for each mirror.
EUnitType | ReadActiveStaticInputType (EAxis axis)
| Returns active static input type. Determined by active control stage system.
void | WriteAngle (EAxis axis, float value)
| Sets static input in XY coordinates. Range is from -1.0 to 1.0.
ushort | ReadAdcRawValue (EAxis axis)
| Returns converted ADC raw value.
EUnitType | ReadActiveInputType (EAxis axis)
| Returns active analog input type. Determined by active control stage system.
float | ReadCurrent (EAxis axis)
| Returns static input in amperes. Range is from -0.7 to 0.7.
float | ReadAngle (EAxis axis)
| Returns static input in XY coordinates. Range is from -1.0 to 1.0.
float | ReadOpticalFeedback (EAxis axis)
| Returns static input in OF. Range differs for each mirror.
float | ReadAmplitude (EAxis axis)
| Returns amplitude of generated signal.
float | ReadFrequency (EAxis axis)
| Returns frequency in Hz of generated signal.
float | ReadPhaseDelay (EAxis axis)
| Returns phase in rad of generated signal.
EWaveformShape | ReadShape (EAxis axis)
| Returns shape of waveform.
void | WriteShape (EAxis axis, EWaveformShape shape)
| Sets shape of waveform.
void | WriteAmplitude (EAxis axis, float value)
| Sets amplitude of generated signal.
void | WriteFrequency (EAxis axis, float value)
| Sets frequency in Hz of generated signal.
void | WritePhaseDelay (EAxis axis, float phaseDelay)
| Sets phase in rad of generated signal.
float | ReadDutyCycles (EAxis axis)
| Returns duty cycle of square and pulse shapes (ignored for other shape types)
void | WriteDutyCycles (EAxis axis, float dutyCycles)
| Sets duty cycle of square and pulse shapes (ignored for other shape types)
void | WriteOffset (EAxis axis, float offset)
| Sets offset of generated signal.
void | WriteScale (EAxis axis, float scale)
| Sets multiplier of input.
float | ReadOffset (EAxis axis)
| Returns offset of generated signal.
float | ReadScale (EAxis axis)
| Returns multiplier of input.
void | ChangeActiveSystem (EAxis axis, EmrEInputStageSystems inputStageSystem)
| Changes active input system of the axis.
EmrEInputStageSystems | ReadActiveSystem (EAxis axis)
| Returns active input system of the axis.
void | ChangeActiveSystem (EMrEControlModeSystems mrE2ControlModeSystem, EAxis axis)
| Sets active control mode system of the axis.
void | WriteSignalGeneratorValues (SignalGeneratorValuesDto singleAxis, EAxis axis)
| Sets object populated with signal generator values.
SignalGeneratorValuesDto | ReadSignalGeneratorValues (EAxis axis)
| Returns object populated with signal generator values.
float | GetSampleRate (EAxis axis)
| Returns sample rate in Hz.
void | SetSampleRate (EAxis axis, float value)
| Sets sample rate in Hz.
float | GetMinimumSamplingRate (EAxis axis)
| Returns minimum sampling rate in Hz.
float | GetMaximumSamplingRate (EAxis axis)
| Returns maximum sampling rate in Hz.
void | WriteExternalTrigger (EAxis axis, EExternalTriggerType trigger)
| Sets flag. If true, turning on the signal generator can be synchronized with an external signal.
float | ReadCurrentLimit (EAxis axis)
| Returns limit in amperes where the output clamps.
void | WriteCurrentLimit (EAxis axis, float value)
| Sets limit in amperes where the output clamps.
int | ReadChannelNumber (EAxis axis)
| Returns channel number.
float | ReadActualCurrent (EAxis axis)
| Returns current current output in amperes for axis.
void | WriteDeviceTemperatureThreshold (float temperatureThreshold)
| Sets device temperature threshold.
float | ReadDeviceTemperatureThreshold ()
| Returns board temperature threshold.
float | ReadDeviceTemperature ()
| Returns device temperature.
void | LoadSnapshot (int snapshotNumber)
| Loads the snapshot by it's number.
void | SaveSnapshot (int snapshotNumber)
| Saves current configuration to the snapshot by it's number.
int | ReadNumberOfAvailableSnapshots ()
| Returns number of available snapshot slots.
void | LockMirrorEepromWriting ()
| Locks mirror EEPROM writing.
void | UnlockMirrorEepromWriting ()
| Unlocks mirror EEPROM writing.
void | LockWriting ()
| Locks board EEPROM writing.
void | UnlockWriting ()
| Unlocks board EEPROM writing.
int | ReadStartupSnapshotNumber ()
| Returns snapshot's number that is load on system startup.
void | WriteStartupSnapshotNumber (int snapshotNumber)
| Sets snapshot's number that is load on system startup.
int | ReadErrorSystemId ()
| Returns ID of system which caused the last snapshot error.
int | ReadErrorRegisterId ()
| Returns ID of register which caused the last snapshot error.
int | ReadErrorValue ()
| Returns ID of value which caused the last snapshot error.
void | ReparseMirrorEeprom ()
| Reparse mirror EEPROM.
float | ReadAverageLimitPeriod (EAxis axis)
| Returns number of seconds to average current.
void | WriteAverageLimitPeriod (EAxis axis, float value)
| Sets number of seconds to average current.
float | ReadAverageLimitSum (EAxis axis)
| Returns maximum allowed average current in amperes.
void | WriteAverageLimitSum (EAxis axis, float value)
| Sets maximum allowed average current in amperes.
float | ReadCooldownPeriod (EAxis axis)
| Returns length of cool-down period in seconds.
void | WriteCooldownPeriod (EAxis axis, float value)
| Sets length of cool-down period in seconds.
float | ReadActualOutputOpticalFeedback (EAxis axis)
| Returns actual output optical feedback.
int | ReadLoggedRegisterAddress (int registerNumber)
| Returns address of register to log in the corresponding vector.
void | WriteLoggedRegisterAddress (int registerNumber, ushort registerAddress)
| Sets address of register to log in the corresponding vector.
void | StartLogger ()
| Starts logger. Will be stopped after the memory is filled.
void | StopLogger ()
| Stops logger.
bool | IsLoggerRunning ()
| Returns logger running status.
float | ReadLoggerSamplingRate ()
| Returns sampling rate in Hz which the logger logs values.
void | WriteLoggerSamplingRate (float samplingRate)
| Sets sampling rate in Hz which the logger logs values.
float | ReadLoggerMinimumSamplingFrequency ()
| Returns minimum sampling rate in Hz which the logger logs values.
float | ReadLoggerMaximumSamplingFrequency ()
| Returns maximum sampling rate in Hz which the logger logs values.
float[] | ReadLoggerRegisterLog (int registerNumber, int startIndex=0, int count=5000)
| Returns logged values for corresponding registers.
byte[] | ReadVectorData ()
| Returns vector data to write or read.
void | WriteVectorData (byte[] vectorData)
| Sets vector data to write or read.
int | ReadVectorAddress ()
| Returns vector address ('System ID' + 'Vector ID') to write or read.
void | WriteVectorAddress (int vectorAddress)
| Sets vector address ('System ID' + 'Vector ID') to write or read.
uint | ReadVectorIndex ()
| Returns index within vector to write or read.
void | WriteVectorIndex (uint vectorIndex)
| Sets index within vector to write or read.
uint | ReadDataSize ()
| Returns number of bytes to write or read. Can be between 1 and 4.
void | WriteDataSize (uint dataSize)
| Sets number of bytes to write or read. Can be between 1 and 4.
void | WriteVector ()
| Writes vector. After writing, vector index is automatically incremented by the data size.
void | ReadVector ()
| Reads vector. After reading, vector index is automatically incremented by the data size.
int | ReadErrorFlag ()
| Returns the error flag returned by the previous write or read operation.
int | ReadSpiReadPointer0Address ()
| Returns the address of the register that will be used to update the read back bytes 4-7 in the slave response.
void | WriteSpiReadPointer0Address (int address)
| Sets the address of the register that will be used to update the read back bytes 4-7 in the slave response.
int | ReadSpiReadPointer1Address ()
| Returns the address of the register that will be used to update the read back bytes 8-11 in the slave response.
void | WriteSpiReadPointer1Address (int address)
| Sets the address of the register that will be used to update the read back bytes 8-11 in the slave response.
uint | ReadSystemTick ()
| Returns system tick. Register value is incremented by one at the controller frequency (10kHz).
int | ReadI2CReadPointer0Address ()
| Returns the address of the register that will be used to evaluate the first register in the read request. Value is updated at controller frequency.
void | WriteI2CReadPointer0Address (int address)
| Sets the address of the register that will be used to evaluate the first register in the read request. Value is updated at controller frequency.
int | ReadI2CReadPointer1Address ()
| Returns the address of the register that will be used to evaluate the second register in the read request.Value is updated at controller frequency.
void | WriteI2CReadPointer1Address (int address)
| Sets the address of the register that will be used to evaluate the second register in the read request.Value is updated at controller frequency.
uint | ReaI2CErrorResponse0 ()
| Returns error response of the first register of the write request.
uint | ReaI2CErrorResponse1 ()
| Returns error response of the second register of the write request.
bool | GetFrontEndPowerState ()
| Setting of FrontEnd power supply state.
void | SetFrontEndPowerState (bool value)
| Setting of FrontEnd power supply state.
float | GetFrontEndVoltage ()
| Setting of FrontEnd supply voltage [V].
void | SetFrontEndVoltage (float value)
| Setting of FrontEnd supply voltage [V].
int | GetOutputStagePWMFrequency ()
| Setting of PWM frequency [400, 500, 600, 1000 and 1200 kHz].
void | SetOutputStagePWMFrequency (int pwmFrequency)
| Setting of PWM frequency [400, 500, 600, 1000 and 1200 kHz].
bool | IsOutputStageEnabled (EAxis axis)
| Setting of output stage state on axis.
void | EnableOutputStage (bool enable, EAxis axis)
| Setting of output stage state on axis.
float | GetADCI (EAxis axis)
| Reading of current on axis.
float | GetADCV (EAxis axis)
| Reading of voltage on axis.
int | GetDevPower (EAxis axis)
| Setting 3v3 for device on axis.
void | SetDevPower (int value, EAxis axis)
| Setting 3v3 for device on axis.
float | GetUin ()
| Reading input voltage.
float | GetIin ()
| Reading input current.
float | GetUfe ()
| Reading FE voltage.
float | GetAnalogInput (EAxis axis)
| Reading of analog input on axis.
float | GetPinAverage ()
| Reading average input power (integration time = 1 second)
void | SetGpioState (int value)
| Sets logical level on GPIO pins (bitwise; 0=LOW, 1=HIGH) Bit# 0 - external GPIO0 1 - external GPIO1 2 - external GPIO2 3 - external GPIO3 4 - internal GPIO_IN0 5 - internal GPIO_IN1 6 - internal GPIO_IN4 7 - internal GPIO_IN5.
int | GetGPIOState ()
| Gets logical level on GPIO pins (bitwise; 0=LOW, 1=HIGH) Bit# 0 - external GPIO0 1 - external GPIO1 2 - external GPIO2 3 - external GPIO3 4 - internal GPIO_IN0 5 - internal GPIO_IN1 6 - internal GPIO_IN4 7 - internal GPIO_IN5.
void | SetGpioDirection (int value)
| Set direction of GPIO pins(bitwise; 0=INPUT, 1=OUTPUT) Bit# 0 - external GPIO0 1 - external GPIO1 2 - external GPIO2 3 - external GPIO3 4 - internal GPIO_IN0 5 - internal GPIO_IN1 6 - internal GPIO_IN4 7 - internal GPIO_IN5.
int | GetGPIODirection ()
| Get direction of GPIO pins(bitwise; 0=INPUT, 1=OUTPUT) Bit# 0 - external GPIO0 1 - external GPIO1 2 - external GPIO2 3 - external GPIO3 4 - internal GPIO_IN0 5 - internal GPIO_IN1 6 - internal GPIO_IN4 7 - internal GPIO_IN5.
int | GetWcState ()
| Reading returns WC state.
void | SetWcState (int value)
| Writing sets state of WC output signal.
int | GetDeviceDetectChannelMask ()
| Enable autodetection on channel (bitwise) - two channels only.
void | SetDeviceDetectChannelMask (int value)
| Enable autodetection on channel (bitwise) - two channels only Input Range 0 - 3.
float | ReadProxyTemperature ()
| Returns board temperature.
void | WriteProxyTemperatureThreshold (float temperatureThreshold)
| Sets board temperature threshold.
float | ReadProxyTemperatureThreshold ()
| Returns board temperature threshold.
float | ReadBoardOutputStageTemperature ()
| Returns board output stage temperature.
void | WriteBoardOutputStageTemperatureThreshold (float temperatureThreshold)
| Sets board output stage temperature threshold.
float | ReadBoardOutputStageTemperatureThreshold ()
| Returns board output stage temperature threshold.
EOperationMode | GetOperationMode ()
| Configures both channels of driver into specific mode: 0 - Open loop, 1 - Close loop Optical Feedback, 2 - Close loop XY, 3 - Resonant mirror mode.
void | SetOperationMode (EOperationMode value)
| Configures both channels of driver into specific mode: 0 - Open loop, 1 - Close loop Optical Feedback, 2 - Close loop XY, 3 - Resonant mirror mode.
bool | IsGainScheduling (EAxis axis)
| Returns enabled/disabled flag of gain scheduling function.
void | SwitchGainScheduling (EAxis axis, bool enabled)
| Enables/disables gain scheduling function.
float | ReadPGain (EAxis axis)
| Returns proportional term.
void | WritePGain (EAxis axis, float pGain)
| Sets proportional term.
float | ReadIGain (EAxis axis)
| Returns integral term.
void | WriteIGain (EAxis axis, float iGain)
| Sets integral term.
float | ReadDGain (EAxis axis)
| Returns derivative term.
void | WriteDGain (EAxis axis, float dGain)
| Sets derivative term.
float | ReadMinimumOutput (EAxis axis)
| Returns minimum allowable output before clamping.
void | WriteMinimumOutput (EAxis axis, float minimumOutput)
| Sets minimum allowable output before clamping.
float | ReadMaximumOutput (EAxis axis)
| Returns maximum allowable output before clamping.
void | WriteMaximumOutput (EAxis axis, float maximumOutput)
| Sets maximum allowable output before clamping.
float | ReadMinimumIntegral (EAxis axis)
| Returns minimum allowable integral before clamping.
void | WriteMinimumIntegral (EAxis axis, float minimumIntegral)
| Sets minimum allowable integral before clamping.
float | ReadMaximumIntegral (EAxis axis)
| Returns maximum allowable integral before clamping.
void | WriteMaximumIntegral (EAxis axis, float maximumIntegral)
| Sets maximum allowable integral before clamping.
bool | ReadDerivativeTermFilterEnabled (EAxis axis)
| Returns flag enabled/disabled a 2nd order low pass Butterworth filter acting on the derivative term.
void | SwitchDerivativeTermFilter (EAxis axis, bool enabled)
| Enables/disables a 2nd order low pass Butterworth filter acting on the derivative term.
float | ReadCutOffFrequency (EAxis axis)
| Returns cut-off frequency in Hz of the 2nd order low pass Butterworth filter acting on the derivative term. Range (0 - 5000).
void | WriteCutOffFrequency (EAxis axis, float frequency)
| Sets cut-off frequency in Hz of the 2nd order low pass Butterworth filter acting on the derivative term. Range (0 - 5000).
float | ReadActualMirrorCoordinate (EAxis axis)
| Returns actual output from PID XY.
byte[] | GetValue (int registerId)
| Returns register value.
bool | SetValue (int registerId, ValueType value)
| Set register value and returns if write was successful.
byte[] | GetVector (int registerId, int index, int count)
| Get vector value on input register with desired lenght.
bool | SetVector (int registerId, int index, byte[] vector)
| Set vector value on input register and returns if write was successful.
void | SetStartIndex (EAxis axis, int startIndex)
| Set Index of first desired point in Vector Pattern Memory (start of transition triggered by rising edge of external signal if External trigger configured)
void | SetEndIndex (EAxis axis, int endIndex)
| Set Index after last desired point in Vector Pattern Memory (end of transition triggered by rising edge of external signal if External trigger configured)
int | GetStartIndex (EAxis axis)
| Get Index of first desired point in Vector Pattern Memory (start of transition triggered by rising edge of external signal if External trigger configured)
int | GetEndIndex (EAxis axis)
| Get Index after last desired point in Vector Pattern Memory (end of transition triggered by rising edge of external signal if External trigger configured)
Public Member Functions inherited from MrEModuleSdk.Devices.Mre3.IMrE3SdkComDeviceController
Public Member Functions inherited from MrEModuleSdk.Devices.SdkInterfaces.IStatus
Public Member Functions inherited from MrEModuleSdk.Devices.SdkInterfaces.IBoardEEPROM
Public Member Functions inherited from MrEModuleSdk.Devices.SdkInterfaces.IDeviceEEPROM
Public Member Functions inherited from MrEModuleSdk.Devices.SdkInterfaces.IMre3TemperatureManager
Public Member Functions inherited from MrEModuleSdk.Devices.SdkInterfaces.IOpticalFeedback
Public Member Functions inherited from MrEModuleSdk.Devices.SdkInterfaces.IRadialBasisFunction
Public Member Functions inherited from MrEModuleSdk.Devices.SdkInterfaces.ILogger
Public Member Functions inherited from MrEModuleSdk.Devices.SdkInterfaces.IMiscellaneousFeatures
Public Member Functions inherited from MrEModuleSdk.Devices.SdkInterfaces.ISnapshotManager
Public Member Functions inherited from MrEModuleSdk.Devices.SdkInterfaces.IVectorAdapter
Public Member Functions inherited from MrEModuleSdk.Devices.SdkInterfaces.ISpi
Public Member Functions inherited from MrEModuleSdk.Devices.SdkInterfaces.II2C
Public Member Functions inherited from MrEModuleSdk.Devices.SdkInterfaces.SignalFlowManager.IInputStage
Public Member Functions inherited from MrEModuleSdk.Devices.SdkInterfaces.SignalFlowManager.IControlModeStage
Public Member Functions inherited from MrEModuleSdk.Devices.SdkInterfaces.SignalFlowManager.InputStage.IStaticValue
Public Member Functions inherited from MrEModuleSdk.Devices.SdkInterfaces.SignalFlowManager.InputStage.IAnalogInput
Public Member Functions inherited from MrEModuleSdk.Devices.SdkInterfaces.SignalFlowManager.InputStage.ISignalGenerator
Public Member Functions inherited from MrEModuleSdk.Devices.SdkInterfaces.SignalFlowManager.InputStage.IArbitraryVector
Public Member Functions inherited from MrEModuleSdk.Devices.SdkInterfaces.SignalFlowManager.ControlMode.IXYPid
Public Member Functions inherited from MrEModuleSdk.Devices.SdkInterfaces.SignalFlowManager.IOffsetAndScale
Public Member Functions inherited from MrEModuleSdk.Devices.SdkInterfaces.SignalFlowManager.ILinearOutput

## Properties
IStatus | Status`[get]`
IBoardEEPROM | BoardEeprom`[get]`
IDeviceEEPROM | DeviceEeprom`[get]`
IMre3TemperatureManager | TemperatureManager`[get]`
ILogger | Logger`[get]`
IMiscellaneousFeatures | MiscellaneousFeatures`[get]`
ISnapshotManager | SnapshotManager`[get]`
IOpticalFeedback | OpticalFeedback`[get]`
IRadialBasisFunction | RadialBasisFunction`[get]`
ISignalFlowManager | SignalFlowManager`[get]`
IInputStage | InputStage`[get]`
IInputConditioningStage | InputConditioningStage`[get]`
IControlModeStage | ControlModeStage`[get]`
IOutputStage | OutputStage`[get]`
IStaticValue | StaticValue`[get]`
IAnalogInput | AnalogInput`[get]`
ISignalGenerator | SignalGenerator`[get]`
IArbitraryVector | ArbitraryVector`[get]`
IXYPid | XYPid`[get]`
IVectorAdapter | VectorAdapter`[get]`
ISpi | Spi`[get]`
II2C | I2C`[get]`
IOffsetAndScale | OffsetAndScale`[get]`
ILinearOutput | LinearOutput`[get]`
Properties inherited from MrEModuleSdk.Devices.Mre3.IMrE3SdkComDeviceController
Properties inherited from MrEModuleSdk.Devices.SdkInterfaces.SignalFlowManager.ISignalFlowManager
Properties inherited from MrEModuleSdk.Devices.SdkInterfaces.SignalFlowManager.IInputStage
Properties inherited from MrEModuleSdk.Devices.SdkInterfaces.SignalFlowManager.IInputConditioningStage
Properties inherited from MrEModuleSdk.Devices.SdkInterfaces.SignalFlowManager.IControlModeStage
Properties inherited from MrEModuleSdk.Devices.SdkInterfaces.SignalFlowManager.IOutputStage

## Member Function Documentation

## ◆ ChangeActiveSystem() [1/2]

void MrEModuleSdk.Devices.Mre3.MrE3SdkComDeviceController.ChangeActiveSystem | ( | EAxis | axis,
|  | EmrEInputStageSystems | selectedInputStageSystem )

Changes active input system of the axis.

Returns

Implements MrEModuleSdk.Devices.SdkInterfaces.SignalFlowManager.IInputStage.

## ◆ ChangeActiveSystem() [2/2]

void MrEModuleSdk.Devices.Mre3.MrE3SdkComDeviceController.ChangeActiveSystem | ( | EMrEControlModeSystems | mrE2ControlModeSystem,
|  | EAxis | axis )

Sets active control mode system of the axis.

Returns

Implements MrEModuleSdk.Devices.SdkInterfaces.SignalFlowManager.IControlModeStage.

## ◆ ChangeModeToPro()

bool MrEModuleSdk.Devices.Mre3.MrE3SdkComDeviceController.ChangeModeToPro | ( |  | ) |

Switches device to PRO mode.

Returns

Implements MrEModuleSdk.Devices.Mre3.IMrE3SdkComDeviceController.

## ◆ ChangeModeToSimple()

bool MrEModuleSdk.Devices.Mre3.MrE3SdkComDeviceController.ChangeModeToSimple | ( |  | ) |

Switches device to SIMPLE mode.

Returns

Implements MrEModuleSdk.Devices.Mre3.IMrE3SdkComDeviceController.

## ◆ Connect()

bool MrEModuleSdk.Devices.Mre3.MrE3SdkComDeviceController.Connect | ( | int | port | ) |

Connects to the device on given port.

Parameters

  port |

Returns

Implements MrEModuleSdk.Devices.Mre3.IMrE3SdkComDeviceController.

## ◆ Disconnect()

void MrEModuleSdk.Devices.Mre3.MrE3SdkComDeviceController.Disconnect | ( | bool | cleanUp | ) |

Disconnects from the device.

Implements MrEModuleSdk.Devices.Mre3.IMrE3SdkComDeviceController.

## ◆ EnableOutputStage()

void MrEModuleSdk.Devices.Mre3.MrE3SdkComDeviceController.EnableOutputStage | ( | bool | enable,
|  | EAxis | axis )

Setting of output stage state on axis.

Returns

Implements MrEModuleSdk.Devices.SdkInterfaces.IMiscellaneousFeatures.

## ◆ GetADCI()

float MrEModuleSdk.Devices.Mre3.MrE3SdkComDeviceController.GetADCI | ( | EAxis | axis | ) |

Reading of current on axis.

Returns

Implements MrEModuleSdk.Devices.SdkInterfaces.IMiscellaneousFeatures.

## ◆ GetADCV()

float MrEModuleSdk.Devices.Mre3.MrE3SdkComDeviceController.GetADCV | ( | EAxis | axis | ) |

Reading of voltage on axis.

Returns

Implements MrEModuleSdk.Devices.SdkInterfaces.IMiscellaneousFeatures.

## ◆ GetAnalogInput()

float MrEModuleSdk.Devices.Mre3.MrE3SdkComDeviceController.GetAnalogInput | ( | EAxis | axis | ) |

Reading of analog input on axis.

Returns

Implements MrEModuleSdk.Devices.SdkInterfaces.IMiscellaneousFeatures.

## ◆ GetBoardFirmwareBranch()

int MrEModuleSdk.Devices.Mre3.MrE3SdkComDeviceController.GetBoardFirmwareBranch | ( |  | ) |

Returns branch ID of the electronic.

Returns

Implements MrEModuleSdk.Devices.SdkInterfaces.IStatus.

## ◆ GetBoardFirmwareBuildVersion()

int MrEModuleSdk.Devices.Mre3.MrE3SdkComDeviceController.GetBoardFirmwareBuildVersion | ( |  | ) |

Returns firmware build version of the electronic.

Returns

Implements MrEModuleSdk.Devices.SdkInterfaces.IStatus.

## ◆ GetBoardFirmwareId()

int MrEModuleSdk.Devices.Mre3.MrE3SdkComDeviceController.GetBoardFirmwareId | ( |  | ) |

Returns firmware ID of the electronic.

Returns

Implements MrEModuleSdk.Devices.SdkInterfaces.IStatus.

## ◆ GetBoardFirmwareMajorVersion()

int MrEModuleSdk.Devices.Mre3.MrE3SdkComDeviceController.GetBoardFirmwareMajorVersion | ( |  | ) |

Returns firmware major version of the electronic.

Returns

Implements MrEModuleSdk.Devices.SdkInterfaces.IStatus.

## ◆ GetBoardFirmwareMinorVersion()

int MrEModuleSdk.Devices.Mre3.MrE3SdkComDeviceController.GetBoardFirmwareMinorVersion | ( |  | ) |

Returns firmware minor version of the electronic.

Returns

Implements MrEModuleSdk.Devices.SdkInterfaces.IStatus.

## ◆ GetBoardFirmwareRevisionVersion()

int MrEModuleSdk.Devices.Mre3.MrE3SdkComDeviceController.GetBoardFirmwareRevisionVersion | ( |  | ) |

Returns firmware revision version of the electronic.

Returns

Implements MrEModuleSdk.Devices.SdkInterfaces.IStatus.

## ◆ GetBoardFirmwareType()

char MrEModuleSdk.Devices.Mre3.MrE3SdkComDeviceController.GetBoardFirmwareType | ( |  | ) |

Returns type of the electronic.

Returns

Implements MrEModuleSdk.Devices.SdkInterfaces.IStatus.

## ◆ GetBytes()

byte[] MrEModuleSdk.Devices.Mre3.MrE3SdkComDeviceController.GetBytes | ( | int | index,
|  | int | length )

Returns board EEPROM bytes starting at index provided as parameter.

Returns

Implements MrEModuleSdk.Devices.SdkInterfaces.IBoardEEPROM.

## ◆ GetDeviceDetectChannelMask()

int MrEModuleSdk.Devices.Mre3.MrE3SdkComDeviceController.GetDeviceDetectChannelMask | ( |  | ) |

Enable autodetection on channel (bitwise) - two channels only.

Returns

Implements MrEModuleSdk.Devices.SdkInterfaces.IBoardEEPROM.

## ◆ GetDeviceStatus()

IDeviceErrorState[] MrEModuleSdk.Devices.Mre3.MrE3SdkComDeviceController.GetDeviceStatus | ( |  | ) |

Returns states of the device.

Returns

Implements MrEModuleSdk.Devices.SdkInterfaces.IStatus.

## ◆ GetDevPower()

int MrEModuleSdk.Devices.Mre3.MrE3SdkComDeviceController.GetDevPower | ( | EAxis | axis | ) |

Setting 3v3 for device on axis.

Returns

Implements MrEModuleSdk.Devices.SdkInterfaces.IMiscellaneousFeatures.

## ◆ GetEepromSubVersion()

int MrEModuleSdk.Devices.Mre3.MrE3SdkComDeviceController.GetEepromSubVersion | ( |  | ) |

Returns EEPROM subversion.

Returns

Implements MrEModuleSdk.Devices.SdkInterfaces.IDeviceEEPROM.

## ◆ GetEepromVersion()

int MrEModuleSdk.Devices.Mre3.MrE3SdkComDeviceController.GetEepromVersion | ( |  | ) |

Returns EEPROM version.

Returns

Implements MrEModuleSdk.Devices.SdkInterfaces.IDeviceEEPROM.

## ◆ GetElectronicSerialNumber()

string MrEModuleSdk.Devices.Mre3.MrE3SdkComDeviceController.GetElectronicSerialNumber | ( |  | ) |

Returns serial number of the electronic.

Returns

Implements MrEModuleSdk.Devices.Mre3.IMrE3SdkComDeviceController.

## ◆ GetEndIndex()

int MrEModuleSdk.Devices.Mre3.MrE3SdkComDeviceController.GetEndIndex | ( | EAxis | axis | ) |

Get Index after last desired point in Vector Pattern Memory (end of transition triggered by rising edge of external signal if External trigger configured)

Returns

Implements MrEModuleSdk.Devices.SdkInterfaces.SignalFlowManager.InputStage.IArbitraryVector.

## ◆ GetFirmwareSerialNumber()

string MrEModuleSdk.Devices.Mre3.MrE3SdkComDeviceController.GetFirmwareSerialNumber | ( |  | ) |

Returns firmware serial number.

Returns

Implements MrEModuleSdk.Devices.SdkInterfaces.IStatus.

## ◆ GetFrontEndPowerState()

bool MrEModuleSdk.Devices.Mre3.MrE3SdkComDeviceController.GetFrontEndPowerState | ( |  | ) |

Setting of FrontEnd power supply state.

Returns
  true/false

Implements MrEModuleSdk.Devices.SdkInterfaces.IMiscellaneousFeatures.

## ◆ GetFrontEndVoltage()

float MrEModuleSdk.Devices.Mre3.MrE3SdkComDeviceController.GetFrontEndVoltage | ( |  | ) |

Setting of FrontEnd supply voltage [V].

Returns

Implements MrEModuleSdk.Devices.SdkInterfaces.IMiscellaneousFeatures.

## ◆ GetGPIODirection()

int MrEModuleSdk.Devices.Mre3.MrE3SdkComDeviceController.GetGPIODirection | ( |  | ) |

Get direction of GPIO pins(bitwise; 0=INPUT, 1=OUTPUT) Bit# 0 - external GPIO0 1 - external GPIO1 2 - external GPIO2 3 - external GPIO3 4 - internal GPIO_IN0 5 - internal GPIO_IN1 6 - internal GPIO_IN4 7 - internal GPIO_IN5.

Returns

Implements MrEModuleSdk.Devices.SdkInterfaces.IMiscellaneousFeatures.

## ◆ GetGPIOState()

int MrEModuleSdk.Devices.Mre3.MrE3SdkComDeviceController.GetGPIOState | ( |  | ) |

Gets logical level on GPIO pins (bitwise; 0=LOW, 1=HIGH) Bit# 0 - external GPIO0 1 - external GPIO1 2 - external GPIO2 3 - external GPIO3 4 - internal GPIO_IN0 5 - internal GPIO_IN1 6 - internal GPIO_IN4 7 - internal GPIO_IN5.

Returns

Implements MrEModuleSdk.Devices.SdkInterfaces.IMiscellaneousFeatures.

## ◆ GetIin()

float MrEModuleSdk.Devices.Mre3.MrE3SdkComDeviceController.GetIin | ( |  | ) |

Reading input current.

Returns

Implements MrEModuleSdk.Devices.SdkInterfaces.IMiscellaneousFeatures.

## ◆ GetMaximumSamplingRate()

float MrEModuleSdk.Devices.Mre3.MrE3SdkComDeviceController.GetMaximumSamplingRate | ( | EAxis | axis | ) |

Returns maximum sampling rate in Hz.

Returns

Implements MrEModuleSdk.Devices.SdkInterfaces.SignalFlowManager.InputStage.IArbitraryVector.

## ◆ GetMaxNegativeCurrent()

int MrEModuleSdk.Devices.Mre3.MrE3SdkComDeviceController.GetMaxNegativeCurrent | ( |  | ) |

Returns max negative current.

Returns

Implements MrEModuleSdk.Devices.SdkInterfaces.IDeviceEEPROM.

## ◆ GetMaxPositiveCurrent()

int MrEModuleSdk.Devices.Mre3.MrE3SdkComDeviceController.GetMaxPositiveCurrent | ( |  | ) |

Returns max positive current.

Returns

Implements MrEModuleSdk.Devices.SdkInterfaces.IDeviceEEPROM.

## ◆ GetMinimumSamplingRate()

float MrEModuleSdk.Devices.Mre3.MrE3SdkComDeviceController.GetMinimumSamplingRate | ( | EAxis | axis | ) |

Returns minimum sampling rate in Hz.

Returns

Implements MrEModuleSdk.Devices.SdkInterfaces.SignalFlowManager.InputStage.IArbitraryVector.

## ◆ GetOperationMode()

EOperationMode MrEModuleSdk.Devices.Mre3.MrE3SdkComDeviceController.GetOperationMode | ( |  | ) |

Configures both channels of driver into specific mode: 0 - Open loop, 1 - Close loop Optical Feedback, 2 - Close loop XY, 3 - Resonant mirror mode.

Returns

Implements MrEModuleSdk.Devices.SdkInterfaces.IMiscellaneousFeatures.

## ◆ GetOutputStagePWMFrequency()

int MrEModuleSdk.Devices.Mre3.MrE3SdkComDeviceController.GetOutputStagePWMFrequency | ( |  | ) |

Setting of PWM frequency [400, 500, 600, 1000 and 1200 kHz].

Returns

Implements MrEModuleSdk.Devices.SdkInterfaces.IMiscellaneousFeatures.

## ◆ GetPartConfiguration()

int MrEModuleSdk.Devices.Mre3.MrE3SdkComDeviceController.GetPartConfiguration | ( |  | ) |

Returns part configuration value.

Returns

Implements MrEModuleSdk.Devices.SdkInterfaces.IDeviceEEPROM.

## ◆ GetPartConfigurationVersion()

int MrEModuleSdk.Devices.Mre3.MrE3SdkComDeviceController.GetPartConfigurationVersion | ( |  | ) |

Returns part configuration version value.

Returns

Implements MrEModuleSdk.Devices.SdkInterfaces.IDeviceEEPROM.

## ◆ GetPinAverage()

float MrEModuleSdk.Devices.Mre3.MrE3SdkComDeviceController.GetPinAverage | ( |  | ) |

Reading average input power (integration time = 1 second)

Returns

Implements MrEModuleSdk.Devices.SdkInterfaces.IMiscellaneousFeatures.

## ◆ GetProductSerialNumber()

string MrEModuleSdk.Devices.Mre3.MrE3SdkComDeviceController.GetProductSerialNumber | ( |  | ) |

Returns serial number of the product.

Returns

Implements MrEModuleSdk.Devices.Mre3.IMrE3SdkComDeviceController.

## ◆ GetSampleRate()

float MrEModuleSdk.Devices.Mre3.MrE3SdkComDeviceController.GetSampleRate | ( | EAxis | axis | ) |

Returns sample rate in Hz.

Returns

Implements MrEModuleSdk.Devices.SdkInterfaces.SignalFlowManager.InputStage.IArbitraryVector.

## ◆ GetStartIndex()

int MrEModuleSdk.Devices.Mre3.MrE3SdkComDeviceController.GetStartIndex | ( | EAxis | axis | ) |

Get Index of first desired point in Vector Pattern Memory (start of transition triggered by rising edge of external signal if External trigger configured)

Returns

Implements MrEModuleSdk.Devices.SdkInterfaces.SignalFlowManager.InputStage.IArbitraryVector.

## ◆ GetUfe()

float MrEModuleSdk.Devices.Mre3.MrE3SdkComDeviceController.GetUfe | ( |  | ) |

Reading FE voltage.

Returns

Implements MrEModuleSdk.Devices.SdkInterfaces.IMiscellaneousFeatures.

## ◆ GetUin()

float MrEModuleSdk.Devices.Mre3.MrE3SdkComDeviceController.GetUin | ( |  | ) |

Reading input voltage.

Returns

Implements MrEModuleSdk.Devices.SdkInterfaces.IMiscellaneousFeatures.

## ◆ GetValue()

byte[] MrEModuleSdk.Devices.Mre3.MrE3SdkComDeviceController.GetValue | ( | int | registerId | ) |

Returns register value.

Returns

Implements MrEModuleSdk.Devices.Mre3.IMrE3SdkComDeviceController.

## ◆ GetVector()

byte[] MrEModuleSdk.Devices.Mre3.MrE3SdkComDeviceController.GetVector | ( | int | registerId,
|  | int | index,
|  | int | count )

Get vector value on input register with desired lenght.

Returns

Implements MrEModuleSdk.Devices.Mre3.IMrE3SdkComDeviceController.

## ◆ GetWcState()

int MrEModuleSdk.Devices.Mre3.MrE3SdkComDeviceController.GetWcState | ( |  | ) |

Reading returns WC state.

Returns

Implements MrEModuleSdk.Devices.SdkInterfaces.IMiscellaneousFeatures.

## ◆ GoToDfuMode()

bool MrEModuleSdk.Devices.Mre3.MrE3SdkComDeviceController.GoToDfuMode | ( |  | ) |

Switches device to DFU mode.

Returns

Implements MrEModuleSdk.Devices.Mre3.IMrE3SdkComDeviceController.

## ◆ IsConnected()

bool MrEModuleSdk.Devices.Mre3.MrE3SdkComDeviceController.IsConnected | ( |  | ) |

Returns true, if connection to device is established.

Returns

Implements MrEModuleSdk.Devices.Mre3.IMrE3SdkComDeviceController.

## ◆ IsGainScheduling()

bool MrEModuleSdk.Devices.Mre3.MrE3SdkComDeviceController.IsGainScheduling | ( | EAxis | axis | ) |

Returns enabled/disabled flag of gain scheduling function.

Returns

Implements MrEModuleSdk.Devices.SdkInterfaces.SignalFlowManager.ControlMode.IXYPid.

## ◆ IsLoggerRunning()

bool MrEModuleSdk.Devices.Mre3.MrE3SdkComDeviceController.IsLoggerRunning | ( |  | ) |

Returns logger running status.

Returns

Implements MrEModuleSdk.Devices.SdkInterfaces.ILogger.

## ◆ IsOutputStageEnabled()

bool MrEModuleSdk.Devices.Mre3.MrE3SdkComDeviceController.IsOutputStageEnabled | ( | EAxis | axis | ) |

Setting of output stage state on axis.

Returns

Implements MrEModuleSdk.Devices.SdkInterfaces.IMiscellaneousFeatures.

## ◆ LoadSnapshot()

void MrEModuleSdk.Devices.Mre3.MrE3SdkComDeviceController.LoadSnapshot | ( | int | snapshotNumber | ) |

Loads the snapshot by it's number.

Returns

Implements MrEModuleSdk.Devices.SdkInterfaces.ISnapshotManager.

## ◆ LockMirrorEepromWriting()

void MrEModuleSdk.Devices.Mre3.MrE3SdkComDeviceController.LockMirrorEepromWriting | ( |  | ) |

Locks mirror EEPROM writing.

Returns

Implements MrEModuleSdk.Devices.SdkInterfaces.IDeviceEEPROM.

## ◆ LockWriting()

void MrEModuleSdk.Devices.Mre3.MrE3SdkComDeviceController.LockWriting | ( |  | ) |

Locks board EEPROM writing.

Returns

Implements MrEModuleSdk.Devices.SdkInterfaces.IBoardEEPROM.

## ◆ ReadActiveInputType()

EUnitType MrEModuleSdk.Devices.Mre3.MrE3SdkComDeviceController.ReadActiveInputType | ( | EAxis | axis | ) |

Returns active analog input type. Determined by active control stage system.

Returns

Implements MrEModuleSdk.Devices.SdkInterfaces.SignalFlowManager.InputStage.IAnalogInput.

## ◆ ReadActiveStaticInputType()

EUnitType MrEModuleSdk.Devices.Mre3.MrE3SdkComDeviceController.ReadActiveStaticInputType | ( | EAxis | axis | ) |

Returns active static input type. Determined by active control stage system.

Returns

Implements MrEModuleSdk.Devices.SdkInterfaces.SignalFlowManager.InputStage.IStaticValue.

## ◆ ReadActiveSystem()

EmrEInputStageSystems MrEModuleSdk.Devices.Mre3.MrE3SdkComDeviceController.ReadActiveSystem | ( | EAxis | axis | ) |

Returns active input system of the axis.

Returns

Implements MrEModuleSdk.Devices.SdkInterfaces.SignalFlowManager.IInputStage.

## ◆ ReadActualCurrent()

float MrEModuleSdk.Devices.Mre3.MrE3SdkComDeviceController.ReadActualCurrent | ( | EAxis | axis | ) |

Returns current current output in amperes for axis.

Returns

Implements MrEModuleSdk.Devices.SdkInterfaces.SignalFlowManager.ILinearOutput.

## ◆ ReadActualMirrorCoordinate()

float MrEModuleSdk.Devices.Mre3.MrE3SdkComDeviceController.ReadActualMirrorCoordinate | ( | EAxis | axis | ) |

Returns actual output from PID XY.

Returns

Implements MrEModuleSdk.Devices.SdkInterfaces.IRadialBasisFunction.

## ◆ ReadActualOutputOpticalFeedback()

float MrEModuleSdk.Devices.Mre3.MrE3SdkComDeviceController.ReadActualOutputOpticalFeedback | ( | EAxis | axis | ) |

Returns actual output optical feedback.

Returns

Implements MrEModuleSdk.Devices.SdkInterfaces.IOpticalFeedback.

## ◆ ReadAdcRawValue()

ushort MrEModuleSdk.Devices.Mre3.MrE3SdkComDeviceController.ReadAdcRawValue | ( | EAxis | axis | ) |

Returns converted ADC raw value.

Returns

Implements MrEModuleSdk.Devices.SdkInterfaces.SignalFlowManager.InputStage.IAnalogInput.

## ◆ ReadAmplitude()

float MrEModuleSdk.Devices.Mre3.MrE3SdkComDeviceController.ReadAmplitude | ( | EAxis | axis | ) |

Returns amplitude of generated signal.

Returns

Implements MrEModuleSdk.Devices.SdkInterfaces.SignalFlowManager.InputStage.ISignalGenerator.

## ◆ ReadAngle()

float MrEModuleSdk.Devices.Mre3.MrE3SdkComDeviceController.ReadAngle | ( | EAxis | axis | ) |

Returns static input in XY coordinates. Range is from -1.0 to 1.0.

Returns

Implements MrEModuleSdk.Devices.SdkInterfaces.SignalFlowManager.InputStage.IStaticValue.

## ◆ ReadAverageLimitPeriod()

float MrEModuleSdk.Devices.Mre3.MrE3SdkComDeviceController.ReadAverageLimitPeriod | ( | EAxis | axis | ) |

Returns number of seconds to average current.

Returns

Implements MrEModuleSdk.Devices.SdkInterfaces.SignalFlowManager.ILinearOutput.

## ◆ ReadAverageLimitSum()

float MrEModuleSdk.Devices.Mre3.MrE3SdkComDeviceController.ReadAverageLimitSum | ( | EAxis | axis | ) |

Returns maximum allowed average current in amperes.

Returns

Implements MrEModuleSdk.Devices.SdkInterfaces.SignalFlowManager.ILinearOutput.

## ◆ ReadBoardOutputStageTemperature()

float MrEModuleSdk.Devices.Mre3.MrE3SdkComDeviceController.ReadBoardOutputStageTemperature | ( |  | ) |

Returns board output stage temperature.

Returns

Implements MrEModuleSdk.Devices.SdkInterfaces.IMre3TemperatureManager.

## ◆ ReadBoardOutputStageTemperatureThreshold()

float MrEModuleSdk.Devices.Mre3.MrE3SdkComDeviceController.ReadBoardOutputStageTemperatureThreshold | ( |  | ) |

Returns board output stage temperature threshold.

Returns

Implements MrEModuleSdk.Devices.SdkInterfaces.IMre3TemperatureManager.

## ◆ ReadChannelNumber()

int MrEModuleSdk.Devices.Mre3.MrE3SdkComDeviceController.ReadChannelNumber | ( | EAxis | axis | ) |

Returns channel number.

Returns

Implements MrEModuleSdk.Devices.SdkInterfaces.SignalFlowManager.ILinearOutput.

## ◆ ReadCooldownPeriod()

float MrEModuleSdk.Devices.Mre3.MrE3SdkComDeviceController.ReadCooldownPeriod | ( | EAxis | axis | ) |

Returns length of cool-down period in seconds.

Returns

Implements MrEModuleSdk.Devices.SdkInterfaces.SignalFlowManager.ILinearOutput.

## ◆ ReadCurrent()

float MrEModuleSdk.Devices.Mre3.MrE3SdkComDeviceController.ReadCurrent | ( | EAxis | axis | ) |

Returns static input in amperes. Range is from -0.7 to 0.7.

Returns

Implements MrEModuleSdk.Devices.SdkInterfaces.SignalFlowManager.InputStage.IStaticValue.

## ◆ ReadCurrentLimit()

float MrEModuleSdk.Devices.Mre3.MrE3SdkComDeviceController.ReadCurrentLimit | ( | EAxis | axis | ) |

Returns limit in amperes where the output clamps.

Returns

Implements MrEModuleSdk.Devices.SdkInterfaces.SignalFlowManager.ILinearOutput.

## ◆ ReadCutOffFrequency()

float MrEModuleSdk.Devices.Mre3.MrE3SdkComDeviceController.ReadCutOffFrequency | ( | EAxis | axis | ) |

Returns cut-off frequency in Hz of the 2nd order low pass Butterworth filter acting on the derivative term. Range (0 - 5000).

Returns

Implements MrEModuleSdk.Devices.SdkInterfaces.SignalFlowManager.ControlMode.IXYPid.

## ◆ ReadDataSize()

uint MrEModuleSdk.Devices.Mre3.MrE3SdkComDeviceController.ReadDataSize | ( |  | ) |

Returns number of bytes to write or read. Can be between 1 and 4.

Returns

Implements MrEModuleSdk.Devices.SdkInterfaces.IVectorAdapter.

## ◆ ReadDerivativeTermFilterEnabled()

bool MrEModuleSdk.Devices.Mre3.MrE3SdkComDeviceController.ReadDerivativeTermFilterEnabled | ( | EAxis | axis | ) |

Returns flag enabled/disabled a 2nd order low pass Butterworth filter acting on the derivative term.

Returns

Implements MrEModuleSdk.Devices.SdkInterfaces.SignalFlowManager.ControlMode.IXYPid.

## ◆ ReadDeviceTemperature()

float MrEModuleSdk.Devices.Mre3.MrE3SdkComDeviceController.ReadDeviceTemperature | ( |  | ) |

Returns device temperature.

Returns

Implements MrEModuleSdk.Devices.SdkInterfaces.IMre3TemperatureManager.

## ◆ ReadDeviceTemperatureThreshold()

float MrEModuleSdk.Devices.Mre3.MrE3SdkComDeviceController.ReadDeviceTemperatureThreshold | ( |  | ) |

Returns board temperature threshold.

Returns

Implements MrEModuleSdk.Devices.SdkInterfaces.IMre3TemperatureManager.

## ◆ ReadDGain()

float MrEModuleSdk.Devices.Mre3.MrE3SdkComDeviceController.ReadDGain | ( | EAxis | axis | ) |

Returns derivative term.

Returns

Implements MrEModuleSdk.Devices.SdkInterfaces.SignalFlowManager.ControlMode.IXYPid.

## ◆ ReadDutyCycles()

float MrEModuleSdk.Devices.Mre3.MrE3SdkComDeviceController.ReadDutyCycles | ( | EAxis | axis | ) |

Returns duty cycle of square and pulse shapes (ignored for other shape types)

Returns

Implements MrEModuleSdk.Devices.SdkInterfaces.SignalFlowManager.InputStage.ISignalGenerator.

## ◆ ReadErrorFlag()

int MrEModuleSdk.Devices.Mre3.MrE3SdkComDeviceController.ReadErrorFlag | ( |  | ) |

Returns the error flag returned by the previous write or read operation.

Returns

Implements MrEModuleSdk.Devices.SdkInterfaces.IVectorAdapter.

## ◆ ReadErrorRegisterId()

int MrEModuleSdk.Devices.Mre3.MrE3SdkComDeviceController.ReadErrorRegisterId | ( |  | ) |

Returns ID of register which caused the last snapshot error.

Returns

Implements MrEModuleSdk.Devices.SdkInterfaces.ISnapshotManager.

## ◆ ReadErrorSystemId()

int MrEModuleSdk.Devices.Mre3.MrE3SdkComDeviceController.ReadErrorSystemId | ( |  | ) |

Returns ID of system which caused the last snapshot error.

Returns

Implements MrEModuleSdk.Devices.SdkInterfaces.ISnapshotManager.

## ◆ ReadErrorValue()

int MrEModuleSdk.Devices.Mre3.MrE3SdkComDeviceController.ReadErrorValue | ( |  | ) |

Returns ID of value which caused the last snapshot error.

Returns

Implements MrEModuleSdk.Devices.SdkInterfaces.ISnapshotManager.

## ◆ ReadFrequency()

float MrEModuleSdk.Devices.Mre3.MrE3SdkComDeviceController.ReadFrequency | ( | EAxis | axis | ) |

Returns frequency in Hz of generated signal.

Returns

Implements MrEModuleSdk.Devices.SdkInterfaces.SignalFlowManager.InputStage.ISignalGenerator.

## ◆ ReadI2CReadPointer0Address()

int MrEModuleSdk.Devices.Mre3.MrE3SdkComDeviceController.ReadI2CReadPointer0Address | ( |  | ) |

Returns the address of the register that will be used to evaluate the first register in the read request. Value is updated at controller frequency.

Returns

Implements MrEModuleSdk.Devices.SdkInterfaces.II2C.

## ◆ ReadI2CReadPointer1Address()

int MrEModuleSdk.Devices.Mre3.MrE3SdkComDeviceController.ReadI2CReadPointer1Address | ( |  | ) |

Returns the address of the register that will be used to evaluate the second register in the read request.Value is updated at controller frequency.

Returns

Implements MrEModuleSdk.Devices.SdkInterfaces.II2C.

## ◆ ReadIGain()

float MrEModuleSdk.Devices.Mre3.MrE3SdkComDeviceController.ReadIGain | ( | EAxis | axis | ) |

Returns integral term.

Returns

Implements MrEModuleSdk.Devices.SdkInterfaces.SignalFlowManager.ControlMode.IXYPid.

## ◆ ReadLoggedRegisterAddress()

int MrEModuleSdk.Devices.Mre3.MrE3SdkComDeviceController.ReadLoggedRegisterAddress | ( | int | registerNumber | ) |

Returns address of register to log in the corresponding vector.

Parameters

  registerNumber | Number of register 0,1,2,3,4,5>

Returns

Implements MrEModuleSdk.Devices.SdkInterfaces.ILogger.

## ◆ ReadLoggerMaximumSamplingFrequency()

float MrEModuleSdk.Devices.Mre3.MrE3SdkComDeviceController.ReadLoggerMaximumSamplingFrequency | ( |  | ) |

Returns maximum sampling rate in Hz which the logger logs values.

Returns

Implements MrEModuleSdk.Devices.SdkInterfaces.ILogger.

## ◆ ReadLoggerMinimumSamplingFrequency()

float MrEModuleSdk.Devices.Mre3.MrE3SdkComDeviceController.ReadLoggerMinimumSamplingFrequency | ( |  | ) |

Returns minimum sampling rate in Hz which the logger logs values.

Returns

Implements MrEModuleSdk.Devices.SdkInterfaces.ILogger.

## ◆ ReadLoggerRegisterLog()

float[] MrEModuleSdk.Devices.Mre3.MrE3SdkComDeviceController.ReadLoggerRegisterLog | ( | int | registerNumber,
|  | int | startIndex = 0,
|  | int | count = 5000 )

Returns logged values for corresponding registers.

Parameters

  registerNumber | Number of register 0,1,2,3,4,5>
  startIndex |
  count |

Returns

Implements MrEModuleSdk.Devices.SdkInterfaces.ILogger.

## ◆ ReadLoggerSamplingRate()

float MrEModuleSdk.Devices.Mre3.MrE3SdkComDeviceController.ReadLoggerSamplingRate | ( |  | ) |

Returns sampling rate in Hz which the logger logs values.

Returns

Implements MrEModuleSdk.Devices.SdkInterfaces.ILogger.

## ◆ ReadMaximumIntegral()

float MrEModuleSdk.Devices.Mre3.MrE3SdkComDeviceController.ReadMaximumIntegral | ( | EAxis | axis | ) |

Returns maximum allowable integral before clamping.

Returns

Implements MrEModuleSdk.Devices.SdkInterfaces.SignalFlowManager.ControlMode.IXYPid.

## ◆ ReadMaximumOutput()

float MrEModuleSdk.Devices.Mre3.MrE3SdkComDeviceController.ReadMaximumOutput | ( | EAxis | axis | ) |

Returns maximum allowable output before clamping.

Returns

Implements MrEModuleSdk.Devices.SdkInterfaces.SignalFlowManager.ControlMode.IXYPid.

## ◆ ReadMinimumIntegral()

float MrEModuleSdk.Devices.Mre3.MrE3SdkComDeviceController.ReadMinimumIntegral | ( | EAxis | axis | ) |

Returns minimum allowable integral before clamping.

Returns

Implements MrEModuleSdk.Devices.SdkInterfaces.SignalFlowManager.ControlMode.IXYPid.

## ◆ ReadMinimumOutput()

float MrEModuleSdk.Devices.Mre3.MrE3SdkComDeviceController.ReadMinimumOutput | ( | EAxis | axis | ) |

Returns minimum allowable output before clamping.

Returns

Implements MrEModuleSdk.Devices.SdkInterfaces.SignalFlowManager.ControlMode.IXYPid.

## ◆ ReadNumberOfAvailableSnapshots()

int MrEModuleSdk.Devices.Mre3.MrE3SdkComDeviceController.ReadNumberOfAvailableSnapshots | ( |  | ) |

Returns number of available snapshot slots.

Returns

Implements MrEModuleSdk.Devices.SdkInterfaces.ISnapshotManager.

## ◆ ReadOffset()

float MrEModuleSdk.Devices.Mre3.MrE3SdkComDeviceController.ReadOffset | ( | EAxis | axis | ) |

Returns offset of generated signal.

Returns

Implements MrEModuleSdk.Devices.SdkInterfaces.SignalFlowManager.InputStage.ISignalGenerator.

## ◆ ReadOpticalFeedback()

float MrEModuleSdk.Devices.Mre3.MrE3SdkComDeviceController.ReadOpticalFeedback | ( | EAxis | axis | ) |

Returns static input in OF. Range differs for each mirror.

Returns

Implements MrEModuleSdk.Devices.SdkInterfaces.SignalFlowManager.InputStage.IStaticValue.

## ◆ ReadPGain()

float MrEModuleSdk.Devices.Mre3.MrE3SdkComDeviceController.ReadPGain | ( | EAxis | axis | ) |

Returns proportional term.

Returns

Implements MrEModuleSdk.Devices.SdkInterfaces.SignalFlowManager.ControlMode.IXYPid.

## ◆ ReadPhaseDelay()

float MrEModuleSdk.Devices.Mre3.MrE3SdkComDeviceController.ReadPhaseDelay | ( | EAxis | axis | ) |

Returns phase in rad of generated signal.

Returns

Implements MrEModuleSdk.Devices.SdkInterfaces.SignalFlowManager.InputStage.ISignalGenerator.

## ◆ ReadProxyTemperature()

float MrEModuleSdk.Devices.Mre3.MrE3SdkComDeviceController.ReadProxyTemperature | ( |  | ) |

Returns board temperature.

Returns

Implements MrEModuleSdk.Devices.SdkInterfaces.IMre3TemperatureManager.

## ◆ ReadProxyTemperatureThreshold()

float MrEModuleSdk.Devices.Mre3.MrE3SdkComDeviceController.ReadProxyTemperatureThreshold | ( |  | ) |

Returns board temperature threshold.

Returns

Implements MrEModuleSdk.Devices.SdkInterfaces.IMre3TemperatureManager.

## ◆ ReadScale()

float MrEModuleSdk.Devices.Mre3.MrE3SdkComDeviceController.ReadScale | ( | EAxis | axis | ) |

Returns multiplier of input.

Returns

Implements MrEModuleSdk.Devices.SdkInterfaces.SignalFlowManager.IOffsetAndScale.

## ◆ ReadShape()

EWaveformShape MrEModuleSdk.Devices.Mre3.MrE3SdkComDeviceController.ReadShape | ( | EAxis | axis | ) |

Returns shape of waveform.

Returns

Implements MrEModuleSdk.Devices.SdkInterfaces.SignalFlowManager.InputStage.ISignalGenerator.

## ◆ ReadSignalGeneratorValues()

SignalGeneratorValuesDto MrEModuleSdk.Devices.Mre3.MrE3SdkComDeviceController.ReadSignalGeneratorValues | ( | EAxis | axis | ) |

Returns object populated with signal generator values.

Returns

Implements MrEModuleSdk.Devices.SdkInterfaces.SignalFlowManager.InputStage.ISignalGenerator.

## ◆ ReadSpiReadPointer0Address()

int MrEModuleSdk.Devices.Mre3.MrE3SdkComDeviceController.ReadSpiReadPointer0Address | ( |  | ) |

Returns the address of the register that will be used to update the read back bytes 4-7 in the slave response.

Returns

Implements MrEModuleSdk.Devices.SdkInterfaces.ISpi.

## ◆ ReadSpiReadPointer1Address()

int MrEModuleSdk.Devices.Mre3.MrE3SdkComDeviceController.ReadSpiReadPointer1Address | ( |  | ) |

Returns the address of the register that will be used to update the read back bytes 8-11 in the slave response.

Returns

Implements MrEModuleSdk.Devices.SdkInterfaces.ISpi.

## ◆ ReadStartupSnapshotNumber()

int MrEModuleSdk.Devices.Mre3.MrE3SdkComDeviceController.ReadStartupSnapshotNumber | ( |  | ) |

Returns snapshot's number that is load on system startup.

Returns

Implements MrEModuleSdk.Devices.SdkInterfaces.ISnapshotManager.

## ◆ ReadSystemTick()

uint MrEModuleSdk.Devices.Mre3.MrE3SdkComDeviceController.ReadSystemTick | ( |  | ) |

Returns system tick. Register value is incremented by one at the controller frequency (10kHz).

Returns

Implements MrEModuleSdk.Devices.SdkInterfaces.ISpi.

## ◆ ReadVector()

void MrEModuleSdk.Devices.Mre3.MrE3SdkComDeviceController.ReadVector | ( |  | ) |

Reads vector. After reading, vector index is automatically incremented by the data size.

Returns

Implements MrEModuleSdk.Devices.SdkInterfaces.IVectorAdapter.

## ◆ ReadVectorAddress()

int MrEModuleSdk.Devices.Mre3.MrE3SdkComDeviceController.ReadVectorAddress | ( |  | ) |

Returns vector address ('System ID' + 'Vector ID') to write or read.

Returns

Implements MrEModuleSdk.Devices.SdkInterfaces.IVectorAdapter.

## ◆ ReadVectorData()

byte[] MrEModuleSdk.Devices.Mre3.MrE3SdkComDeviceController.ReadVectorData | ( |  | ) |

Returns vector data to write or read.

Returns

Implements MrEModuleSdk.Devices.SdkInterfaces.IVectorAdapter.

## ◆ ReadVectorIndex()

uint MrEModuleSdk.Devices.Mre3.MrE3SdkComDeviceController.ReadVectorIndex | ( |  | ) |

Returns index within vector to write or read.

Returns

Implements MrEModuleSdk.Devices.SdkInterfaces.IVectorAdapter.

## ◆ ReaI2CErrorResponse0()

uint MrEModuleSdk.Devices.Mre3.MrE3SdkComDeviceController.ReaI2CErrorResponse0 | ( |  | ) |

Returns error response of the first register of the write request.

Returns

Implements MrEModuleSdk.Devices.SdkInterfaces.II2C.

## ◆ ReaI2CErrorResponse1()

uint MrEModuleSdk.Devices.Mre3.MrE3SdkComDeviceController.ReaI2CErrorResponse1 | ( |  | ) |

Returns error response of the second register of the write request.

Returns

Implements MrEModuleSdk.Devices.SdkInterfaces.II2C.

## ◆ Reconnect()

bool MrEModuleSdk.Devices.Mre3.MrE3SdkComDeviceController.Reconnect | ( |  | ) |

Reconnects to already connected device.

Returns

Implements MrEModuleSdk.Devices.Mre3.IMrE3SdkComDeviceController.

## ◆ ReparseMirrorEeprom()

void MrEModuleSdk.Devices.Mre3.MrE3SdkComDeviceController.ReparseMirrorEeprom | ( |  | ) |

Reparse mirror EEPROM.

Returns

Implements MrEModuleSdk.Devices.SdkInterfaces.IDeviceEEPROM.

## ◆ ResetErrorFlags()

void MrEModuleSdk.Devices.Mre3.MrE3SdkComDeviceController.ResetErrorFlags | ( |  | ) |

Resets error flag to 0.

Returns

Implements MrEModuleSdk.Devices.SdkInterfaces.IStatus.

## ◆ SaveSnapshot()

void MrEModuleSdk.Devices.Mre3.MrE3SdkComDeviceController.SaveSnapshot | ( | int | snapshotNumber | ) |

Saves current configuration to the snapshot by it's number.

Returns

Implements MrEModuleSdk.Devices.SdkInterfaces.ISnapshotManager.

## ◆ SetBytes()

void MrEModuleSdk.Devices.Mre3.MrE3SdkComDeviceController.SetBytes | ( | int | index,
|  | byte[] | inputBytes )

Sets board EEPROM bytes starting at index provided as parameter.

Returns

Implements MrEModuleSdk.Devices.SdkInterfaces.IBoardEEPROM.

## ◆ SetDeviceDetectChannelMask()

void MrEModuleSdk.Devices.Mre3.MrE3SdkComDeviceController.SetDeviceDetectChannelMask | ( | int | detectMask | ) |

Enable autodetection on channel (bitwise) - two channels only Input Range 0 - 3.

Returns

Implements MrEModuleSdk.Devices.SdkInterfaces.IBoardEEPROM.

## ◆ SetDevPower()

void MrEModuleSdk.Devices.Mre3.MrE3SdkComDeviceController.SetDevPower | ( | int | value,
|  | EAxis | axis )

Setting 3v3 for device on axis.

Returns

Implements MrEModuleSdk.Devices.SdkInterfaces.IMiscellaneousFeatures.

## ◆ SetEndIndex()

void MrEModuleSdk.Devices.Mre3.MrE3SdkComDeviceController.SetEndIndex | ( | EAxis | axis,
|  | int | endIndex )

Set Index after last desired point in Vector Pattern Memory (end of transition triggered by rising edge of external signal if External trigger configured)

Returns

Implements MrEModuleSdk.Devices.SdkInterfaces.SignalFlowManager.InputStage.IArbitraryVector.

## ◆ SetFrontEndPowerState()

void MrEModuleSdk.Devices.Mre3.MrE3SdkComDeviceController.SetFrontEndPowerState | ( | bool | value | ) |

Setting of FrontEnd power supply state.

Returns

Implements MrEModuleSdk.Devices.SdkInterfaces.IMiscellaneousFeatures.

## ◆ SetFrontEndVoltage()

void MrEModuleSdk.Devices.Mre3.MrE3SdkComDeviceController.SetFrontEndVoltage | ( | float | value | ) |

Setting of FrontEnd supply voltage [V].

Returns

Implements MrEModuleSdk.Devices.SdkInterfaces.IMiscellaneousFeatures.

## ◆ SetGpioDirection()

void MrEModuleSdk.Devices.Mre3.MrE3SdkComDeviceController.SetGpioDirection | ( | int | value | ) |

Set direction of GPIO pins(bitwise; 0=INPUT, 1=OUTPUT) Bit# 0 - external GPIO0 1 - external GPIO1 2 - external GPIO2 3 - external GPIO3 4 - internal GPIO_IN0 5 - internal GPIO_IN1 6 - internal GPIO_IN4 7 - internal GPIO_IN5.

Returns

Implements MrEModuleSdk.Devices.SdkInterfaces.IMiscellaneousFeatures.

## ◆ SetGpioState()

void MrEModuleSdk.Devices.Mre3.MrE3SdkComDeviceController.SetGpioState | ( | int | value | ) |

Sets logical level on GPIO pins (bitwise; 0=LOW, 1=HIGH) Bit# 0 - external GPIO0 1 - external GPIO1 2 - external GPIO2 3 - external GPIO3 4 - internal GPIO_IN0 5 - internal GPIO_IN1 6 - internal GPIO_IN4 7 - internal GPIO_IN5.

Returns

Implements MrEModuleSdk.Devices.SdkInterfaces.IMiscellaneousFeatures.

## ◆ SetOperationMode()

void MrEModuleSdk.Devices.Mre3.MrE3SdkComDeviceController.SetOperationMode | ( | EOperationMode | value | ) |

Configures both channels of driver into specific mode: 0 - Open loop, 1 - Close loop Optical Feedback, 2 - Close loop XY, 3 - Resonant mirror mode.

Returns

Implements MrEModuleSdk.Devices.SdkInterfaces.IMiscellaneousFeatures.

## ◆ SetOutputStagePWMFrequency()

void MrEModuleSdk.Devices.Mre3.MrE3SdkComDeviceController.SetOutputStagePWMFrequency | ( | int | value | ) |

Setting of PWM frequency [400, 500, 600, 1000 and 1200 kHz].

Returns

Implements MrEModuleSdk.Devices.SdkInterfaces.IMiscellaneousFeatures.

## ◆ SetSampleRate()

void MrEModuleSdk.Devices.Mre3.MrE3SdkComDeviceController.SetSampleRate | ( | EAxis | axis,
|  | float | value )

Sets sample rate in Hz.

Returns

Implements MrEModuleSdk.Devices.SdkInterfaces.SignalFlowManager.InputStage.IArbitraryVector.

## ◆ SetStartIndex()

void MrEModuleSdk.Devices.Mre3.MrE3SdkComDeviceController.SetStartIndex | ( | EAxis | axis,
|  | int | startIndex )

Set Index of first desired point in Vector Pattern Memory (start of transition triggered by rising edge of external signal if External trigger configured)

Returns

Implements MrEModuleSdk.Devices.SdkInterfaces.SignalFlowManager.InputStage.IArbitraryVector.

## ◆ SetValue()

bool MrEModuleSdk.Devices.Mre3.MrE3SdkComDeviceController.SetValue | ( | int | registerId,
|  | ValueType | value )

Set register value and returns if write was successful.

Returns

Implements MrEModuleSdk.Devices.Mre3.IMrE3SdkComDeviceController.

## ◆ SetVector()

bool MrEModuleSdk.Devices.Mre3.MrE3SdkComDeviceController.SetVector | ( | int | registerId,
|  | int | index,
|  | byte[] | vector )

Set vector value on input register and returns if write was successful.

Returns

Implements MrEModuleSdk.Devices.Mre3.IMrE3SdkComDeviceController.

## ◆ SetWcState()

void MrEModuleSdk.Devices.Mre3.MrE3SdkComDeviceController.SetWcState | ( | int | state | ) |

Writing sets state of WC output signal.

Returns

Implements MrEModuleSdk.Devices.SdkInterfaces.IMiscellaneousFeatures.

## ◆ StartLogger()

void MrEModuleSdk.Devices.Mre3.MrE3SdkComDeviceController.StartLogger | ( |  | ) |

Starts logger. Will be stopped after the memory is filled.

Returns

Implements MrEModuleSdk.Devices.SdkInterfaces.ILogger.

## ◆ StopLogger()

void MrEModuleSdk.Devices.Mre3.MrE3SdkComDeviceController.StopLogger | ( |  | ) |

Stops logger.

Returns

Implements MrEModuleSdk.Devices.SdkInterfaces.ILogger.

## ◆ SwitchDerivativeTermFilter()

void MrEModuleSdk.Devices.Mre3.MrE3SdkComDeviceController.SwitchDerivativeTermFilter | ( | EAxis | axis,
|  | bool | enabled )

Enables/disables a 2nd order low pass Butterworth filter acting on the derivative term.

Returns

Implements MrEModuleSdk.Devices.SdkInterfaces.SignalFlowManager.ControlMode.IXYPid.

## ◆ SwitchGainScheduling()

void MrEModuleSdk.Devices.Mre3.MrE3SdkComDeviceController.SwitchGainScheduling | ( | EAxis | axis,
|  | bool | enabled )

Enables/disables gain scheduling function.

Returns

Implements MrEModuleSdk.Devices.SdkInterfaces.SignalFlowManager.ControlMode.IXYPid.

## ◆ UnlockMirrorEepromWriting()

void MrEModuleSdk.Devices.Mre3.MrE3SdkComDeviceController.UnlockMirrorEepromWriting | ( |  | ) |

Unlocks mirror EEPROM writing.

Returns

Implements MrEModuleSdk.Devices.SdkInterfaces.IDeviceEEPROM.

## ◆ UnlockWriting()

void MrEModuleSdk.Devices.Mre3.MrE3SdkComDeviceController.UnlockWriting | ( |  | ) |

Unlocks board EEPROM writing.

Returns

Implements MrEModuleSdk.Devices.SdkInterfaces.IBoardEEPROM.

## ◆ WriteAmplitude()

void MrEModuleSdk.Devices.Mre3.MrE3SdkComDeviceController.WriteAmplitude | ( | EAxis | axis,
|  | float | value )

Sets amplitude of generated signal.

Returns

Implements MrEModuleSdk.Devices.SdkInterfaces.SignalFlowManager.InputStage.ISignalGenerator.

## ◆ WriteAngle()

void MrEModuleSdk.Devices.Mre3.MrE3SdkComDeviceController.WriteAngle | ( | EAxis | axis,
|  | float | value )

Sets static input in XY coordinates. Range is from -1.0 to 1.0.

Returns

Implements MrEModuleSdk.Devices.SdkInterfaces.SignalFlowManager.InputStage.IStaticValue.

## ◆ WriteAverageLimitPeriod()

void MrEModuleSdk.Devices.Mre3.MrE3SdkComDeviceController.WriteAverageLimitPeriod | ( | EAxis | axis,
|  | float | value )

Sets number of seconds to average current.

Returns

Implements MrEModuleSdk.Devices.SdkInterfaces.SignalFlowManager.ILinearOutput.

## ◆ WriteAverageLimitSum()

void MrEModuleSdk.Devices.Mre3.MrE3SdkComDeviceController.WriteAverageLimitSum | ( | EAxis | axis,
|  | float | value )

Sets maximum allowed average current in amperes.

Returns

Implements MrEModuleSdk.Devices.SdkInterfaces.SignalFlowManager.ILinearOutput.

## ◆ WriteBoardOutputStageTemperatureThreshold()

void MrEModuleSdk.Devices.Mre3.MrE3SdkComDeviceController.WriteBoardOutputStageTemperatureThreshold | ( | float | temperatureThreshold | ) |

Sets board output stage temperature threshold.

Returns

Implements MrEModuleSdk.Devices.SdkInterfaces.IMre3TemperatureManager.

## ◆ WriteCooldownPeriod()

void MrEModuleSdk.Devices.Mre3.MrE3SdkComDeviceController.WriteCooldownPeriod | ( | EAxis | axis,
|  | float | value )

Sets length of cool-down period in seconds.

Returns

Implements MrEModuleSdk.Devices.SdkInterfaces.SignalFlowManager.ILinearOutput.

## ◆ WriteCurrent()

void MrEModuleSdk.Devices.Mre3.MrE3SdkComDeviceController.WriteCurrent | ( | EAxis | axis,
|  | float | value )

Sets static input in amperes. Range is from -0.7 to 0.7.

Returns

Implements MrEModuleSdk.Devices.SdkInterfaces.SignalFlowManager.InputStage.IStaticValue.

## ◆ WriteCurrentLimit()

void MrEModuleSdk.Devices.Mre3.MrE3SdkComDeviceController.WriteCurrentLimit | ( | EAxis | axis,
|  | float | value )

Sets limit in amperes where the output clamps.

Returns

Implements MrEModuleSdk.Devices.SdkInterfaces.SignalFlowManager.ILinearOutput.

## ◆ WriteCutOffFrequency()

void MrEModuleSdk.Devices.Mre3.MrE3SdkComDeviceController.WriteCutOffFrequency | ( | EAxis | axis,
|  | float | frequency )

Sets cut-off frequency in Hz of the 2nd order low pass Butterworth filter acting on the derivative term. Range (0 - 5000).

Returns

Implements MrEModuleSdk.Devices.SdkInterfaces.SignalFlowManager.ControlMode.IXYPid.

## ◆ WriteDataSize()

void MrEModuleSdk.Devices.Mre3.MrE3SdkComDeviceController.WriteDataSize | ( | uint | dataSize | ) |

Sets number of bytes to write or read. Can be between 1 and 4.

Returns

Implements MrEModuleSdk.Devices.SdkInterfaces.IVectorAdapter.

## ◆ WriteDeviceTemperatureThreshold()

void MrEModuleSdk.Devices.Mre3.MrE3SdkComDeviceController.WriteDeviceTemperatureThreshold | ( | float | temperatureThreshold | ) |

Sets device temperature threshold.

Returns

Implements MrEModuleSdk.Devices.SdkInterfaces.IMre3TemperatureManager.

## ◆ WriteDGain()

void MrEModuleSdk.Devices.Mre3.MrE3SdkComDeviceController.WriteDGain | ( | EAxis | axis,
|  | float | dGain )

Sets derivative term.

Returns

Implements MrEModuleSdk.Devices.SdkInterfaces.SignalFlowManager.ControlMode.IXYPid.

## ◆ WriteDutyCycles()

void MrEModuleSdk.Devices.Mre3.MrE3SdkComDeviceController.WriteDutyCycles | ( | EAxis | axis,
|  | float | dutyCycles )

Sets duty cycle of square and pulse shapes (ignored for other shape types)

Returns

Implements MrEModuleSdk.Devices.SdkInterfaces.SignalFlowManager.InputStage.ISignalGenerator.

## ◆ WriteExternalTrigger()

void MrEModuleSdk.Devices.Mre3.MrE3SdkComDeviceController.WriteExternalTrigger | ( | EAxis | axis,
|  | EExternalTriggerType | trigger )

Sets flag. If true, turning on the signal generator can be synchronized with an external signal.

Returns

Implements MrEModuleSdk.Devices.SdkInterfaces.SignalFlowManager.InputStage.ISignalGenerator.

## ◆ WriteFrequency()

void MrEModuleSdk.Devices.Mre3.MrE3SdkComDeviceController.WriteFrequency | ( | EAxis | axis,
|  | float | value )

Sets frequency in Hz of generated signal.

Returns

Implements MrEModuleSdk.Devices.SdkInterfaces.SignalFlowManager.InputStage.ISignalGenerator.

## ◆ WriteI2CReadPointer0Address()

void MrEModuleSdk.Devices.Mre3.MrE3SdkComDeviceController.WriteI2CReadPointer0Address | ( | int | address | ) |

Sets the address of the register that will be used to evaluate the first register in the read request. Value is updated at controller frequency.

Returns

Implements MrEModuleSdk.Devices.SdkInterfaces.II2C.

## ◆ WriteI2CReadPointer1Address()

void MrEModuleSdk.Devices.Mre3.MrE3SdkComDeviceController.WriteI2CReadPointer1Address | ( | int | address | ) |

Sets the address of the register that will be used to evaluate the second register in the read request.Value is updated at controller frequency.

Returns

Implements MrEModuleSdk.Devices.SdkInterfaces.II2C.

## ◆ WriteIGain()

void MrEModuleSdk.Devices.Mre3.MrE3SdkComDeviceController.WriteIGain | ( | EAxis | axis,
|  | float | iGain )

Sets integral term.

Returns

Implements MrEModuleSdk.Devices.SdkInterfaces.SignalFlowManager.ControlMode.IXYPid.

## ◆ WriteLoggedRegisterAddress()

void MrEModuleSdk.Devices.Mre3.MrE3SdkComDeviceController.WriteLoggedRegisterAddress | ( | int | registerNumber,
|  | ushort | registerAddress )

Sets address of register to log in the corresponding vector.

Parameters

  registerNumber | Number of register 0,1,2,3,4,5>
  registerAddress | Register address

Returns

Implements MrEModuleSdk.Devices.SdkInterfaces.ILogger.

## ◆ WriteLoggerSamplingRate()

void MrEModuleSdk.Devices.Mre3.MrE3SdkComDeviceController.WriteLoggerSamplingRate | ( | float | samplingRate | ) |

Sets sampling rate in Hz which the logger logs values.

Returns

Implements MrEModuleSdk.Devices.SdkInterfaces.ILogger.

## ◆ WriteMaximumIntegral()

void MrEModuleSdk.Devices.Mre3.MrE3SdkComDeviceController.WriteMaximumIntegral | ( | EAxis | axis,
|  | float | maximumIntegral )

Sets maximum allowable integral before clamping.

Returns

Implements MrEModuleSdk.Devices.SdkInterfaces.SignalFlowManager.ControlMode.IXYPid.

## ◆ WriteMaximumOutput()

void MrEModuleSdk.Devices.Mre3.MrE3SdkComDeviceController.WriteMaximumOutput | ( | EAxis | axis,
|  | float | maximumOutput )

Sets maximum allowable output before clamping.

Returns

Implements MrEModuleSdk.Devices.SdkInterfaces.SignalFlowManager.ControlMode.IXYPid.

## ◆ WriteMinimumIntegral()

void MrEModuleSdk.Devices.Mre3.MrE3SdkComDeviceController.WriteMinimumIntegral | ( | EAxis | axis,
|  | float | minimumIntegral )

Sets minimum allowable integral before clamping.

Returns

Implements MrEModuleSdk.Devices.SdkInterfaces.SignalFlowManager.ControlMode.IXYPid.

## ◆ WriteMinimumOutput()

void MrEModuleSdk.Devices.Mre3.MrE3SdkComDeviceController.WriteMinimumOutput | ( | EAxis | axis,
|  | float | minimumOutput )

Sets minimum allowable output before clamping.

Returns

Implements MrEModuleSdk.Devices.SdkInterfaces.SignalFlowManager.ControlMode.IXYPid.

## ◆ WriteOffset()

void MrEModuleSdk.Devices.Mre3.MrE3SdkComDeviceController.WriteOffset | ( | EAxis | axis,
|  | float | offset )

Sets offset of generated signal.

Returns

Implements MrEModuleSdk.Devices.SdkInterfaces.SignalFlowManager.InputStage.ISignalGenerator.

## ◆ WriteOpticalFeedback()

void MrEModuleSdk.Devices.Mre3.MrE3SdkComDeviceController.WriteOpticalFeedback | ( | EAxis | axis,
|  | float | value )

Sets static input in OF. Range differs for each mirror.

Returns

Implements MrEModuleSdk.Devices.SdkInterfaces.SignalFlowManager.InputStage.IStaticValue.

## ◆ WritePGain()

void MrEModuleSdk.Devices.Mre3.MrE3SdkComDeviceController.WritePGain | ( | EAxis | axis,
|  | float | pGain )

Sets proportional term.

Returns

Implements MrEModuleSdk.Devices.SdkInterfaces.SignalFlowManager.ControlMode.IXYPid.

## ◆ WritePhaseDelay()

void MrEModuleSdk.Devices.Mre3.MrE3SdkComDeviceController.WritePhaseDelay | ( | EAxis | axis,
|  | float | phaseDelay )

Sets phase in rad of generated signal.

Returns

Implements MrEModuleSdk.Devices.SdkInterfaces.SignalFlowManager.InputStage.ISignalGenerator.

## ◆ WriteProxyTemperatureThreshold()

void MrEModuleSdk.Devices.Mre3.MrE3SdkComDeviceController.WriteProxyTemperatureThreshold | ( | float | temperatureThreshold | ) |

Sets board temperature threshold.

Returns

Implements MrEModuleSdk.Devices.SdkInterfaces.IMre3TemperatureManager.

## ◆ WriteScale()

void MrEModuleSdk.Devices.Mre3.MrE3SdkComDeviceController.WriteScale | ( | EAxis | axis,
|  | float | value )

Sets multiplier of input.

Returns

Implements MrEModuleSdk.Devices.SdkInterfaces.SignalFlowManager.IOffsetAndScale.

## ◆ WriteShape()

void MrEModuleSdk.Devices.Mre3.MrE3SdkComDeviceController.WriteShape | ( | EAxis | axis,
|  | EWaveformShape | shape )

Sets shape of waveform.

Returns

Implements MrEModuleSdk.Devices.SdkInterfaces.SignalFlowManager.InputStage.ISignalGenerator.

## ◆ WriteSignalGeneratorValues()

void MrEModuleSdk.Devices.Mre3.MrE3SdkComDeviceController.WriteSignalGeneratorValues | ( | SignalGeneratorValuesDto | axisValues,
|  | EAxis | axis )

Sets object populated with signal generator values.

Returns

Implements MrEModuleSdk.Devices.SdkInterfaces.SignalFlowManager.InputStage.ISignalGenerator.

## ◆ WriteSpiReadPointer0Address()

void MrEModuleSdk.Devices.Mre3.MrE3SdkComDeviceController.WriteSpiReadPointer0Address | ( | int | address | ) |

Sets the address of the register that will be used to update the read back bytes 4-7 in the slave response.

Returns

Implements MrEModuleSdk.Devices.SdkInterfaces.ISpi.

## ◆ WriteSpiReadPointer1Address()

void MrEModuleSdk.Devices.Mre3.MrE3SdkComDeviceController.WriteSpiReadPointer1Address | ( | int | address | ) |

Sets the address of the register that will be used to update the read back bytes 8-11 in the slave response.

Returns

Implements MrEModuleSdk.Devices.SdkInterfaces.ISpi.

## ◆ WriteStartupSnapshotNumber()

void MrEModuleSdk.Devices.Mre3.MrE3SdkComDeviceController.WriteStartupSnapshotNumber | ( | int | snapshotNumber | ) |

Sets snapshot's number that is load on system startup.

Returns

Implements MrEModuleSdk.Devices.SdkInterfaces.ISnapshotManager.

## ◆ WriteVector()

void MrEModuleSdk.Devices.Mre3.MrE3SdkComDeviceController.WriteVector | ( |  | ) |

Writes vector. After writing, vector index is automatically incremented by the data size.

Returns

Implements MrEModuleSdk.Devices.SdkInterfaces.IVectorAdapter.

## ◆ WriteVectorAddress()

void MrEModuleSdk.Devices.Mre3.MrE3SdkComDeviceController.WriteVectorAddress | ( | int | vectorAddress | ) |

Sets vector address ('System ID' + 'Vector ID') to write or read.

Returns

Implements MrEModuleSdk.Devices.SdkInterfaces.IVectorAdapter.

## ◆ WriteVectorData()

void MrEModuleSdk.Devices.Mre3.MrE3SdkComDeviceController.WriteVectorData | ( | byte[] | vectorData | ) |

Sets vector data to write or read.

Returns

Implements MrEModuleSdk.Devices.SdkInterfaces.IVectorAdapter.

## ◆ WriteVectorIndex()

void MrEModuleSdk.Devices.Mre3.MrE3SdkComDeviceController.WriteVectorIndex | ( | uint | vectorIndex | ) |

Sets index within vector to write or read.

Returns

Implements MrEModuleSdk.Devices.SdkInterfaces.IVectorAdapter.

## Property Documentation

## ◆ AnalogInput

IAnalogInput MrEModuleSdk.Devices.Mre3.MrE3SdkComDeviceController.AnalogInput
| get

Implements MrEModuleSdk.Devices.SdkInterfaces.SignalFlowManager.IInputStage.

## ◆ ArbitraryVector

IArbitraryVector MrEModuleSdk.Devices.Mre3.MrE3SdkComDeviceController.ArbitraryVector
| get

Implements MrEModuleSdk.Devices.SdkInterfaces.SignalFlowManager.IInputStage.

## ◆ BoardEeprom

IBoardEEPROM MrEModuleSdk.Devices.Mre3.MrE3SdkComDeviceController.BoardEeprom
| get

Implements MrEModuleSdk.Devices.Mre3.IMrE3SdkComDeviceController.

## ◆ ControlModeStage

IControlModeStage MrEModuleSdk.Devices.Mre3.MrE3SdkComDeviceController.ControlModeStage
| get

Implements MrEModuleSdk.Devices.SdkInterfaces.SignalFlowManager.ISignalFlowManager.

## ◆ DeviceEeprom

IDeviceEEPROM MrEModuleSdk.Devices.Mre3.MrE3SdkComDeviceController.DeviceEeprom
| get

Implements MrEModuleSdk.Devices.Mre3.IMrE3SdkComDeviceController.

## ◆ I2C

II2C MrEModuleSdk.Devices.Mre3.MrE3SdkComDeviceController.I2C
| get

Implements MrEModuleSdk.Devices.Mre3.IMrE3SdkComDeviceController.

## ◆ InputConditioningStage

IInputConditioningStage MrEModuleSdk.Devices.Mre3.MrE3SdkComDeviceController.InputConditioningStage
| get

Implements MrEModuleSdk.Devices.SdkInterfaces.SignalFlowManager.ISignalFlowManager.

## ◆ InputStage

IInputStage MrEModuleSdk.Devices.Mre3.MrE3SdkComDeviceController.InputStage
| get

Implements MrEModuleSdk.Devices.SdkInterfaces.SignalFlowManager.ISignalFlowManager.

## ◆ LinearOutput

ILinearOutput MrEModuleSdk.Devices.Mre3.MrE3SdkComDeviceController.LinearOutput
| get

Implements MrEModuleSdk.Devices.SdkInterfaces.SignalFlowManager.IOutputStage.

## ◆ Logger

ILogger MrEModuleSdk.Devices.Mre3.MrE3SdkComDeviceController.Logger
| get

Implements MrEModuleSdk.Devices.Mre3.IMrE3SdkComDeviceController.

## ◆ MiscellaneousFeatures

IMiscellaneousFeatures MrEModuleSdk.Devices.Mre3.MrE3SdkComDeviceController.MiscellaneousFeatures
| get

Implements MrEModuleSdk.Devices.Mre3.IMrE3SdkComDeviceController.

## ◆ OffsetAndScale

IOffsetAndScale MrEModuleSdk.Devices.Mre3.MrE3SdkComDeviceController.OffsetAndScale
| get

Implements MrEModuleSdk.Devices.SdkInterfaces.SignalFlowManager.IInputConditioningStage.

## ◆ OpticalFeedback

IOpticalFeedback MrEModuleSdk.Devices.Mre3.MrE3SdkComDeviceController.OpticalFeedback
| get

Implements MrEModuleSdk.Devices.Mre3.IMrE3SdkComDeviceController.

## ◆ OutputStage

IOutputStage MrEModuleSdk.Devices.Mre3.MrE3SdkComDeviceController.OutputStage
| get

Implements MrEModuleSdk.Devices.SdkInterfaces.SignalFlowManager.ISignalFlowManager.

## ◆ RadialBasisFunction

IRadialBasisFunction MrEModuleSdk.Devices.Mre3.MrE3SdkComDeviceController.RadialBasisFunction
| get

Implements MrEModuleSdk.Devices.Mre3.IMrE3SdkComDeviceController.

## ◆ SignalFlowManager

ISignalFlowManager MrEModuleSdk.Devices.Mre3.MrE3SdkComDeviceController.SignalFlowManager
| get

Implements MrEModuleSdk.Devices.Mre3.IMrE3SdkComDeviceController.

## ◆ SignalGenerator

ISignalGenerator MrEModuleSdk.Devices.Mre3.MrE3SdkComDeviceController.SignalGenerator
| get

Implements MrEModuleSdk.Devices.SdkInterfaces.SignalFlowManager.IInputStage.

## ◆ SnapshotManager

ISnapshotManager MrEModuleSdk.Devices.Mre3.MrE3SdkComDeviceController.SnapshotManager
| get

Implements MrEModuleSdk.Devices.Mre3.IMrE3SdkComDeviceController.

## ◆ Spi

ISpi MrEModuleSdk.Devices.Mre3.MrE3SdkComDeviceController.Spi
| get

Implements MrEModuleSdk.Devices.Mre3.IMrE3SdkComDeviceController.

## ◆ StaticValue

IStaticValue MrEModuleSdk.Devices.Mre3.MrE3SdkComDeviceController.StaticValue
| get

Implements MrEModuleSdk.Devices.SdkInterfaces.SignalFlowManager.IInputStage.

## ◆ Status

IStatus MrEModuleSdk.Devices.Mre3.MrE3SdkComDeviceController.Status
| get

Implements MrEModuleSdk.Devices.Mre3.IMrE3SdkComDeviceController.

## ◆ TemperatureManager

IMre3TemperatureManager MrEModuleSdk.Devices.Mre3.MrE3SdkComDeviceController.TemperatureManager
| get

Implements MrEModuleSdk.Devices.Mre3.IMrE3SdkComDeviceController.

## ◆ VectorAdapter

IVectorAdapter MrEModuleSdk.Devices.Mre3.MrE3SdkComDeviceController.VectorAdapter
| get

Implements MrEModuleSdk.Devices.Mre3.IMrE3SdkComDeviceController.

## ◆ XYPid

IXYPid MrEModuleSdk.Devices.Mre3.MrE3SdkComDeviceController.XYPid
| get

Implements MrEModuleSdk.Devices.SdkInterfaces.SignalFlowManager.IControlModeStage.

The documentation for this class was generated from the following file:

- C:/Users/jan.janda/Desktop/Mre3Documentation/MrE3SdkComDeviceController.cs